"{ Package: 'cvut:stx/goodies/libsvn' }"

"{ NameSpace: SVN }"

Notification subclass:#WCActionNotification
	instanceVariableNames:'action entry'
	classVariableNames:''
	poolDictionaries:''
	category:'SVN-Working copy'
!


!WCActionNotification class methodsFor:'instance creation'!

readFromString: string 
    ^ self new readFromString: string

    "Created: / 16-03-2008 / 08:53:50 / janfrog"
!

readFromXml: xmlNode 
    ^ self new readFromXml: xmlNode

    "Created: / 24-06-2009 / 15:02:25 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!WCActionNotification methodsFor:'accessing'!

action
    ^ action

    "Created: / 31-03-2008 / 11:09:26 / janfrog"
!

action:aWCAction
    action := aWCAction.

    "Created: / 31-03-2008 / 11:09:26 / janfrog"
!

entry
    ^ entry
!

entry:aWCEntry
    entry := aWCEntry.
!

icon

    ^action icon

    "Created: / 24-06-2009 / 15:08:17 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

path

    ^entry path

    "Created: / 27-08-2009 / 08:45:12 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

wc: aSVNWorkingCopy

    ^entry wc: aSVNWorkingCopy

    "Created: / 27-08-2009 / 09:50:27 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!WCActionNotification methodsFor:'initialization'!

readFromString: string 
    | pair path |

    pair := string tokensBasedOn: Character space.

    action := WCAction actionNamed: pair first.
    path := pair last.
    (path first = $' and: [ path last = $' ]) 
        ifTrue: [ path := path copyFrom: 2 to: path size - 1 ].
    entry := WCEntry path: path

    "Created: / 16-03-2008 / 08:54:44 / janfrog"
    "Modified: / 16-03-2008 / 10:06:42 / janfrog"
    "Modified: / 27-08-2009 / 08:21:18 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

readFromXml: xml 

    | path |

    "
     <path
       action='M'>/trunk/extensions.st</path>"
    
    action := WCAction actionNamed: (xml @ 'action').
    path := xml characterData.
     "Strip branch prefix"
    (path startsWith: '/trunk/') 
        ifTrue: [ path := entry copyFrom: ('/trunk/' size) + 1 ]
        ifFalse: 
            [ ((path startsWith: '/branches/') or: [ path startsWith: '/tags/' ]) 
                ifTrue: 
                    [ | idx |

                    idx := path indexOf: $/ startingAt: 2.
                    idx := path indexOf: $/ startingAt: idx + 1.
                    idx isZero ifFalse: [ path := path copyFrom: idx + 1 ] ] ].
    entry := WCEntry path: path.

    "Modified: / 16-03-2008 / 10:06:42 / janfrog"
    "Created: / 24-06-2009 / 15:00:43 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 27-08-2009 / 08:22:12 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!WCActionNotification methodsFor:'printing'!

printOn: stream

    action printOn: stream.
    stream tab.
    entry printOn: stream

    "Created: / 16-03-2008 / 09:01:46 / janfrog"
! !

!WCActionNotification methodsFor:'processing'!

processUsing: processor 
    ^ action processEntry: entry using: processor

    "Created: / 27-08-2009 / 08:52:59 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!WCActionNotification class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
!

version_SVN
    ^'Id: SVN__WCActionNotification.st 113 2009-08-28 11:43:01Z vranyj1 '
! !
